=== debian/changelog ===
swiftlang (5.9.2-1ubuntu2) plucky; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 06 Jan 2025 05:30:56 +0100

swiftlang (5.9.2-1ubuntu1) plucky; urgency=medium

  * Fix building with Python 3.13.
  * Try to build on any arch.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 05 Jan 2025 16:33:24 +0100

swiftlang (5.9.2-1build1) plucky; urgency=medium

  * No-change rebuild for Python 3.13 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Jan 2025 12:03:31 +0100

swiftlang (5.9.2-1) unstable; urgency=low

  * New upstream version.

  [ Sylvestre Ledru ]
  * Silent the warnings with dpkg-source

 -- Steve Meliza <swm@swm1.com>  Tue, 24 Dec 2024 17:42:40 -0800
